/* global value list
NEED_COLOR	= TRUE
USE_NORMALMAP	= false
USE_SUNSPEC	= TRUE
*/


#define	Float	highp float
#define	Float2	highp vec2
#define	Float3	highp vec3
#define	Float4	highp vec4
#define	Float3x3	highp mat3
#define	Float4x4	highp mat4
#define	Half	mediump float
#define	Half2	mediump vec2
#define	Half3	mediump vec3
#define	Half4	mediump vec4
#define	Fixed	lowp float
#define	Fixed2	lowp vec2
#define	Fixed3	lowp vec3
#define	Fixed4	lowp vec4
#define	saturate(x)	clamp(x,0.0,1.0)
#define	lerp(a,b,w)	mix(a,b,w)
#define	tex1D		texture1D
#define	tex2D		texture2D
#define	tex2DProj	texture2DProj

		
uniform sampler2D	smpDiffuseMap;
			
uniform sampler2D	smpGlossMap;
		
uniform sampler2D	smpProjTex;
		
uniform Fixed 	u_alpha_test_ref;
		
varying Half4	v_Color;
		
varying Fixed3	v_Spec;
		
varying Half2	v_TexDiff;
			
varying Half4	v_TexProj;
		
void main()
{
		
	Fixed4 c = tex2D(smpDiffuseMap, v_TexDiff.xy);
	Fixed texAlpha = c.a;
			
	if (texAlpha < u_alpha_test_ref)
		discard;
			
	Fixed3 shadow = vec3(1,1,1);
	if (v_TexProj.x<0.0 || v_TexProj.x>1.0 || v_TexProj.y<0.0 || v_TexProj.y>1.0)
		shadow = vec3(1,1,1);
	else
		shadow = tex2DProj(smpProjTex, v_TexProj).rgb;
	c.rgb *= shadow;
		
	mediump vec4 color = v_Color;
			
	Half3 spec = v_Spec;
			
	Half3 gloss = tex2D(smpGlossMap, v_TexDiff.xy).rgb;
	spec *= gloss;
			
	c *= color;
		
	c.rgb += spec;
		
	gl_FragColor = c;
			
}
	